(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@ngrx/effects'), require('rxjs/operators'), require('rxjs'), require('@angular/common'), require('@angular/forms'), require('@ngrx/store'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngrx-store-forms', ['exports', '@ngrx/effects', 'rxjs/operators', 'rxjs', '@angular/common', '@angular/forms', '@ngrx/store', '@angular/core'], factory) :
    (factory((global['ngrx-store-forms'] = {}),global.effects,global.rxjs.operators,global.rxjs,global.ng.common,global.ng.forms,global.store,global.ng.core));
}(this, (function (exports,effects,operators,rxjs,common,forms,store,core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @return {?}
     */
    function noStoreError() {
        throw new Error("No store detected. Make sure you've included @ngrx/store in your application.");
    }
    /**
     * @return {?}
     */
    function noFormGroupError() {
        throw new Error("rxfConnectForm needs to be placed on an element which also contains a formGroup directive.");
    }
    /**
     * @param {?} path
     * @return {?}
     */
    function noStoreFormBinding(path) {
        throw new Error("No binding found for form state on path '" + path + "'.");
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var STORE_FORMS_CONFIG = new core.InjectionToken('rxsf Config');
    /** @type {?} */
    var STORE_FORMS_FEATURE = new core.InjectionToken('rxsf Feature');

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var defaultStoreFormsConfig = {
        bindingStrategy: 'ObserveStore',
        debounce: 100,
        errorMessages: {}
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} object
     * @param {?} path
     * @param {?=} throwOnMiss
     * @return {?}
     */
    function deepGet(object, path, throwOnMiss) {
        if (throwOnMiss === void 0) {
            throwOnMiss = false;
        }
        return path
            .split('.')
            .reduce(function (partialState, pathSegment) {
            if (throwOnMiss && typeof partialState[pathSegment] !== 'object') {
                throw new Error("Path '" + path + "' could not be resolved in object " + object + ". Segment '" + pathSegment + "' was not referring to type object.");
            }
            return partialState[pathSegment] || {};
        }, object);
    }
    /**
     * @param {?} userConfig
     * @return {?}
     */
    function getEffectiveConfig(userConfig) {
        return __assign({}, defaultStoreFormsConfig, userConfig);
    }
    /**
     * @param {?} x
     * @param {?} y
     * @return {?}
     */
    function deepEquals(x, y) {
        if (x === y) {
            return true; // if both x and y are null or undefined and exactly the same
        }
        else if (!(x instanceof Object) || !(y instanceof Object)) {
            return false; // if they are not strictly equal, they both need to be Objects
        }
        else if (x.constructor !== y.constructor) {
            // they must have the exact same prototype chain, the closest we can do is
            // test their constructor.
            return false;
        }
        else {
            for (var p in x) {
                if (!x.hasOwnProperty(p)) {
                    continue; // other properties were tested using x.constructor === y.constructor
                }
                if (!y.hasOwnProperty(p)) {
                    return false; // allows to compare x[ p ] and y[ p ] when set to undefined
                }
                if (x[p] === y[p]) {
                    continue; // if they have the same strict value or identity then they are equal
                }
                if (typeof (x[p]) !== 'object') {
                    return false; // Numbers, Strings, Functions, Booleans must be strictly equal
                }
                if (!deepEquals(x[p], y[p])) {
                    return false;
                }
            }
            for (var p in y) {
                if (y.hasOwnProperty(p) && !x.hasOwnProperty(p)) {
                    return false;
                }
            }
            return true;
        }
    }
    /**
     * @param {?} control
     * @return {?}
     */
    function extractStateBase(control) {
        return {
            dirty: control.dirty,
            invalid: control.invalid,
            pending: control.pending,
            pristine: control.pristine,
            touched: control.touched,
            untouched: control.untouched,
            valid: control.valid,
            disabled: control.disabled,
            enabled: control.enabled
        };
    }
    // TODO: Handle form arrays correctly
    /**
     * @template F
     * @param {?} control
     * @param {?} errorResolver
     * @param {?=} path
     * @return {?}
     */
    function getFormState(control, errorResolver, path) {
        if (path === void 0) {
            path = [];
        }
        if (control instanceof forms.FormGroup) {
            /** @type {?} */
            var fields = Object.keys(control.controls)
                .map(function (key) {
                return ({
                    name: key,
                    state: getFormState(control.controls[key], errorResolver, __spread(path, [key]))
                });
            })
                .reduce(function (reducedFields, entry) {
                reducedFields[entry.name] = entry.state;
                return reducedFields;
            }, ( /** @type {?} */({})));
            return ( /** @type {?} */(__assign({}, extractStateBase(control), { value: ( /** @type {?} */(control.value)), fields: fields, errors: errorResolver(control, path) })));
        }
        else {
            return ( /** @type {?} */(__assign({}, extractStateBase(control), { value: control.value, errors: errorResolver(control, path) })));
        }
    }
    /**
     * @param {?} errors
     * @param {?} path
     * @param {?=} errorMessages
     * @param {?=} pathPrefix
     * @return {?}
     */
    function resolveErrors(errors, path, errorMessages, pathPrefix) {
        if (errorMessages === void 0) {
            errorMessages = {};
        }
        if (pathPrefix === void 0) {
            pathPrefix = [];
        }
        if (!errors) {
            return null;
        }
        /** @type {?} */
        var normalizedPath = path.filter(function (pathElement) { return !(/^[\d\s]+$/g.test(pathElement)); });
        return Object.keys(errors)
            .reduce(function (messages, validatorName) {
            /** @type {?} */
            var wholePath = __spread(pathPrefix, normalizedPath);
            /** @type {?} */
            var resolvedMessage = deepGet(errorMessages, __spread(wholePath, [validatorName]).join('.'));
            if (typeof resolvedMessage === 'object') {
                /** @type {?} */
                var parentSearchPath = __spread(wholePath);
                while (typeof resolvedMessage === 'object' && parentSearchPath.length > 0) {
                    parentSearchPath.pop();
                    resolvedMessage = deepGet(errorMessages, __spread(parentSearchPath, [validatorName]).join('.'));
                }
                if (typeof resolvedMessage === 'object') {
                    resolvedMessage = validatorName;
                }
            }
            if (messages.indexOf(resolvedMessage) === -1) {
                messages.push(resolvedMessage);
            }
            return messages;
        }, []);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template F
     */
    var /**
     * @template F
     */ UpdateStoreFormStateAction = /** @class */ (function () {
        function UpdateStoreFormStateAction(path, formState) {
            this.path = path;
            this.formState = formState;
            this.type = 'UpdateStoreFormStateAction';
        }
        return UpdateStoreFormStateAction;
    }());
    /**
     * @template F
     */
    var /**
     * @template F
     */ UpdateStoreFormAction = /** @class */ (function () {
        function UpdateStoreFormAction(path, value) {
            this.path = path;
            this.value = value;
            this.type = 'UpdateStoreFormAction';
        }
        return UpdateStoreFormAction;
    }());
    var StoreFormsNoopAction = /** @class */ (function () {
        function StoreFormsNoopAction() {
            this.type = 'StoreFormsNoopAction';
        }
        return StoreFormsNoopAction;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var StoreFormsService = /** @class */ (function () {
        function StoreFormsService(config, store$$1, feature) {
            this.store = store$$1;
            this.feature = feature;
            this.bindings = {};
            this.pathPrefix = '';
            this.config = getEffectiveConfig(config);
            if (!this.store) {
                noStoreError();
            }
            if (this.feature) {
                this.pathPrefix = feature + ".";
            }
        }
        /**
         * @param {?} path
         * @param {?} formGroup
         * @return {?}
         */
        StoreFormsService.prototype.bind = /**
         * @param {?} path
         * @param {?} formGroup
         * @return {?}
         */
            function (path, formGroup) {
                var _this = this;
                /** @type {?} */
                var stateUpdateTrigger = new rxjs.Subject();
                /** @type {?} */
                var errorResolver = function (control, controlPath) {
                    return resolveErrors(control.errors, controlPath, _this.config.errorMessages, pathWithPrefix.split('.'));
                };
                /** @type {?} */
                var pathWithPrefix = "" + this.pathPrefix + path;
                /** @type {?} */
                var observeStore = true;
                /** @type {?} */
                var source = rxjs.merge(formGroup.valueChanges.pipe(operators.map(function () { return getFormState(formGroup, errorResolver); })), formGroup.statusChanges.pipe(operators.map(function () { return getFormState(formGroup, errorResolver); })), stateUpdateTrigger.pipe(operators.map(function () { return getFormState(formGroup, errorResolver); })));
                if (this.config.debounce) {
                    source = source.pipe(operators.debounceTime(this.config.debounce));
                }
                /** @type {?} */
                var formGroupSubscription = source
                    .pipe(operators.distinctUntilChanged(function (a, b) { return deepEquals(a, b); }))
                    .subscribe(function () {
                    observeStore = false;
                    _this.store.dispatch(new UpdateStoreFormStateAction(pathWithPrefix, ( /** @type {?} */(getFormState(formGroup, errorResolver)))));
                    observeStore = true;
                });
                this.bindings[pathWithPrefix] = {
                    path: pathWithPrefix,
                    formGroup: formGroup,
                    formGroupSubscription: formGroupSubscription,
                    stateUpdateTrigger: stateUpdateTrigger
                };
                if (this.config.bindingStrategy === 'ObserveStore') {
                    this.bindings[pathWithPrefix].storeSubscription = this.store
                        .pipe(
                    // We skip the initial value emitted by the store subject
                    operators.skip(1), operators.map(function (state) { return deepGet(state, pathWithPrefix); }), operators.filter(function () { return observeStore; }), operators.filter(function (formState) {
                        // Very simple dirty checking by comparing current values in
                        // state to values in form group using deep equal to prevent
                        // unwanted infinite loop
                        return formState.value && Object.keys(formState.value).length && !deepEquals(formState, getFormState(formGroup, errorResolver));
                    }))
                        .subscribe(function (formState) {
                        formGroup.setValue(formState.value);
                    });
                }
            };
        /**
         * @param {?} path
         * @return {?}
         */
        StoreFormsService.prototype.unbind = /**
         * @param {?} path
         * @return {?}
         */
            function (path) {
                /** @type {?} */
                var pathWithPrefix = "" + this.pathPrefix + path;
                if (!this.bindings[pathWithPrefix]) {
                    return;
                }
                this.bindings[pathWithPrefix].formGroupSubscription.unsubscribe();
                if (this.bindings[pathWithPrefix].storeSubscription) {
                    this.bindings[pathWithPrefix].storeSubscription.unsubscribe();
                }
                delete this.bindings[pathWithPrefix];
            };
        /**
         * @param {?} path
         * @param {?} replace
         * @return {?}
         */
        StoreFormsService.prototype.replaceBinding = /**
         * @param {?} path
         * @param {?} replace
         * @return {?}
         */
            function (path, replace) {
                this.unbind(path);
                this.bind(path, replace);
            };
        /**
         * @param {?} path
         * @return {?}
         */
        StoreFormsService.prototype.findBinding = /**
         * @param {?} path
         * @return {?}
         */
            function (path) {
                /** @type {?} */
                var pathWithPrefix = "" + this.pathPrefix + path;
                return this.bindings[pathWithPrefix] || null;
            };
        /**
         * @param {?} path
         * @return {?}
         */
        StoreFormsService.prototype.getFormGroup = /**
         * @param {?} path
         * @return {?}
         */
            function (path) {
                /** @type {?} */
                var binding = this.findBinding(path);
                if (binding) {
                    return binding;
                }
                else {
                    noStoreFormBinding("" + this.pathPrefix + path);
                }
            };
        /**
         * @param {?} path
         * @return {?}
         */
        StoreFormsService.prototype.triggerUpdate = /**
         * @param {?} path
         * @return {?}
         */
            function (path) {
                /** @type {?} */
                var binding = this.findBinding(path);
                if (binding) {
                    binding.stateUpdateTrigger.next();
                }
                else {
                    noStoreFormBinding("" + this.pathPrefix + path);
                }
            };
        /**
         * @param {?} path
         * @param {?} value
         * @return {?}
         */
        StoreFormsService.prototype.updateFormGroup = /**
         * @param {?} path
         * @param {?} value
         * @return {?}
         */
            function (path, value) {
                /** @type {?} */
                var pathWithPrefix = "" + this.pathPrefix + path;
                if (!this.bindings[pathWithPrefix]) {
                    noStoreFormBinding(pathWithPrefix);
                }
                /** @type {?} */
                var binding = this.bindings[pathWithPrefix];
                binding.formGroup.setValue(value);
            };
        StoreFormsService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        StoreFormsService.ctorParameters = function () {
            return [
                { type: undefined, decorators: [{ type: core.Inject, args: [STORE_FORMS_CONFIG,] }] },
                { type: store.Store, decorators: [{ type: core.Optional }] },
                { type: String, decorators: [{ type: core.Inject, args: [STORE_FORMS_FEATURE,] }, { type: core.Optional }] }
            ];
        };
        return StoreFormsService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BindingDirective = /** @class */ (function () {
        function BindingDirective(formGroupDirective, store$$1, storeFormsService) {
            this.formGroupDirective = formGroupDirective;
            this.store = store$$1;
            this.storeFormsService = storeFormsService;
            if (!this.formGroupDirective) {
                noFormGroupError();
            }
            if (!this.store) {
                noStoreError();
            }
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        BindingDirective.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                if (changes.formGroup) {
                    this.storeFormsService.replaceBinding(this.rxsfBinding, this.formGroup);
                }
                else if (changes.rxsfBinding) {
                    this.storeFormsService.unbind(changes.rxsfBinding.previousValue);
                    this.storeFormsService.replaceBinding(this.rxsfBinding, this.formGroup);
                }
            };
        /**
         * @return {?}
         */
        BindingDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.storeFormsService.unbind(this.rxsfBinding);
            };
        BindingDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[rxsfBinding]'
                    },] }
        ];
        /** @nocollapse */
        BindingDirective.ctorParameters = function () {
            return [
                { type: forms.FormGroupDirective, decorators: [{ type: core.Self }, { type: core.Optional }] },
                { type: store.Store, decorators: [{ type: core.Optional }] },
                { type: StoreFormsService }
            ];
        };
        BindingDirective.propDecorators = {
            rxsfBinding: [{ type: core.Input }],
            formGroup: [{ type: core.Input }]
        };
        return BindingDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var StoreFormsEffects = /** @class */ (function () {
        function StoreFormsEffects(actions, bindingService, config, store$$1) {
            var _this = this;
            this.actions = actions;
            this.bindingService = bindingService;
            this.store = store$$1;
            this.reflectToFormStateEffect = this.actions
                .pipe(operators.filter(function (action) { return action instanceof UpdateStoreFormAction; }), operators.switchMap(function (action) {
                if (_this.config.bindingStrategy === 'ObserveStore') {
                    return ( /** @type {?} */(_this.store
                        .pipe(operators.take(1), operators.map(function (state) {
                        /** @type {?} */
                        var formState = deepGet(state, action.path, true);
                        return new UpdateStoreFormStateAction(action.path, __assign({}, formState, { value: __assign({}, formState.value, action.value) }));
                    }))));
                }
                else {
                    _this.bindingService.updateFormGroup(action.path, action.value);
                    return rxjs.of(new StoreFormsNoopAction());
                }
            }));
            this.config = getEffectiveConfig(config);
        }
        StoreFormsEffects.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        StoreFormsEffects.ctorParameters = function () {
            return [
                { type: effects.Actions },
                { type: StoreFormsService },
                { type: undefined, decorators: [{ type: core.Inject, args: [STORE_FORMS_CONFIG,] }] },
                { type: store.Store }
            ];
        };
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], StoreFormsEffects.prototype, "reflectToFormStateEffect", void 0);
        return StoreFormsEffects;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TouchedUpdateDirective = /** @class */ (function () {
        function TouchedUpdateDirective(elementRef, binding, storeFormsService) {
            this.elementRef = elementRef;
            this.binding = binding;
            this.storeFormsService = storeFormsService;
        }
        /**
         * @return {?}
         */
        TouchedUpdateDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (!this.binding) {
                    return;
                }
                this.blurListener = function () { return _this.storeFormsService.triggerUpdate(_this.binding.rxsfBinding); };
                this.elementRef.nativeElement.addEventListener('blur', this.blurListener);
            };
        /**
         * @return {?}
         */
        TouchedUpdateDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.blurListener) {
                    this.elementRef.nativeElement.removeEventListener('blur', this.blurListener);
                }
            };
        TouchedUpdateDirective.decorators = [
            { type: core.Directive, args: [{
                        // tslint:disable-next-line
                        selector: 'input[formControlName],input[formControl]'
                    },] }
        ];
        /** @nocollapse */
        TouchedUpdateDirective.ctorParameters = function () {
            return [
                { type: core.ElementRef },
                { type: BindingDirective, decorators: [{ type: core.SkipSelf }, { type: core.Optional }] },
                { type: StoreFormsService }
            ];
        };
        return TouchedUpdateDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0 = defaultStoreFormsConfig;
    var StoreFormsModule = /** @class */ (function () {
        function StoreFormsModule() {
        }
        /**
         * @param {?=} config
         * @return {?}
         */
        StoreFormsModule.forRoot = /**
         * @param {?=} config
         * @return {?}
         */
            function (config) {
                return {
                    ngModule: StoreFormsModule,
                    providers: [{
                            provide: STORE_FORMS_CONFIG,
                            useValue: config
                        }, {
                            provide: StoreFormsService,
                            useClass: StoreFormsService,
                            deps: [STORE_FORMS_CONFIG, store.Store]
                        }]
                };
            };
        /**
         * @param {?} feature
         * @param {?=} config
         * @return {?}
         */
        StoreFormsModule.forFeature = /**
         * @param {?} feature
         * @param {?=} config
         * @return {?}
         */
            function (feature, config) {
                return {
                    ngModule: StoreFormsModule,
                    providers: [{
                            provide: STORE_FORMS_CONFIG,
                            useValue: config
                        }, {
                            provide: StoreFormsService,
                            useClass: StoreFormsService,
                            deps: [STORE_FORMS_CONFIG, store.Store, STORE_FORMS_FEATURE]
                        }, {
                            provide: STORE_FORMS_FEATURE,
                            useValue: feature
                        }]
                };
            };
        StoreFormsModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            forms.FormsModule,
                            forms.ReactiveFormsModule
                        ],
                        declarations: [
                            BindingDirective,
                            TouchedUpdateDirective
                        ],
                        exports: [
                            BindingDirective,
                            TouchedUpdateDirective
                        ],
                        providers: [{
                                provide: STORE_FORMS_CONFIG,
                                useValue: ɵ0
                            }, {
                                provide: StoreFormsService,
                                useClass: StoreFormsService,
                                deps: [STORE_FORMS_CONFIG, store.Store]
                            }]
                    },] }
        ];
        return StoreFormsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */
    function storeFormsReducer(state, action) {
        switch (action.type) {
            case 'UpdateStoreFormStateAction': {
                /** @type {?} */
                var clone = Object.assign({}, state);
                /** @type {?} */
                var formState = ( /** @type {?} */(action.path
                    .split('.')
                    .reduce(function (partialState, pathSegment) {
                    return partialState[pathSegment] = Object.assign({}, partialState[pathSegment]);
                }, clone)));
                Object.assign(formState, __assign({}, action.formState));
                if (action.formState.value) {
                    Object.assign(formState, {
                        value: __assign({}, formState.value, action.formState.value)
                    });
                }
                return clone;
            }
        }
        return state;
    }
    /**
     * @param {?} reducer
     * @return {?}
     */
    function storeFormsMetaReducer(reducer) {
        return function (state, action) {
            /** @type {?} */
            var updatedState = storeFormsReducer(state, action);
            return reducer(updatedState, action);
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.UpdateStoreFormAction = UpdateStoreFormAction;
    exports.BindingDirective = BindingDirective;
    exports.StoreFormsEffects = StoreFormsEffects;
    exports.StoreFormsModule = StoreFormsModule;
    exports.storeFormsReducer = storeFormsReducer;
    exports.storeFormsMetaReducer = storeFormsMetaReducer;
    exports.StoreFormsService = StoreFormsService;
    exports.STORE_FORMS_CONFIG = STORE_FORMS_CONFIG;
    exports.STORE_FORMS_FEATURE = STORE_FORMS_FEATURE;
    exports.ɵb = defaultStoreFormsConfig;
    exports.ɵa = TouchedUpdateDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngrx-store-forms.umd.js.map